'Generates a list of nets in Excel that have min/max length rules set.  It also reports the routed length of these nets, the value of which is automatically
'colourised red if it falls outside the max length rule and blue if falls below the min length rule..  Note that this script will also take net classes with
'high speed rules into consideration.
'Written by Paul Woolford of millennium technology limited
'Email: paulw@pads-pcb.co.uk
'Date: 03/05/2000

Sub Main

	NoOfNets = ActiveDocument.Nets.Count
	NetCount = 1

	Dim NextNet As Object

	ActiveDocument.ExportRules DefaultFilePath & "\padsnet.rul"
	RulesASCII = DefaultFilePath & "\padsnet.rul"
	Open RulesASCII For Input As #1
	Line Input #1,L1$

	Set xl = CreateObject("Excel.Application")
	xl.Workbooks.Add
	xl.Range("A1:E1") = Array("Net Name","Min Length","Max Length","Routed Length","Difference")
	xl.Range("A1:E1").Font.Bold = True
	xl.Columns("A:E").AutoFit
	Set cell = xl.ActiveCell
	row = 2

	For Each NextNet In ActiveDocument.GetObjects(2, "", False)
		StatusBarText = "Analysing Net " & NetCount & " of " & NoOfNets & " (" & NextNet.Name & ")"
		InClass = False
		Seek #1,1
		While Not EOF(1)
			If Left$(L1$,9) = "NET_CLASS" And L1$ <> "NET_CLASS DATA" Then
				CurrClass = L1$
				Debug.Print CurrClass
				For i = 1 To 2 Step 1
					Line Input #1,L1$
				Next i
				Debug.Print L1$
				While Left$(L1$,4) = "NET "
					If L1$ = "NET " & NextNet.Name Or L1$ = "NET_" & NextNet.Name Then
						InClass = True
						GoTo NetInClass
					End If
					Line Input #1,L1$
				Wend	
			End If
			Line Input #1,L1$
    	Wend

NetInClass:
Seek #1,1
	If InClass Then
		Check = CurrClass
	Else
		Check = "NET " & NextNet.Name
	End If

	While Not EOF(1)
		If L1$ = Check Then
		
			While L1$ <> "}"
				Line Input #1,L1$
			Wend	
				
			For i = 1 To 6 Step 1
				Line Input #1,L1$
			Next i
			If L1$ = "HIGH_SPEED_RULE :" Then
				cell.Item(row, 1) = NextNet.Name
				Line Input #1,L1$
				Line Input #1,L1$
				MinLen = Mid$(L1$,12)
				cell.Item(row, 2) = MinLen
				Line Input #1,L1$
				MaxLen = Mid$(L1$,12)
				cell.Item(row, 3) = MaxLen				
				RoutedLen = Format$(ActiveDocument.Nets(NextNet.Name).Length(True), "Fixed")
				If CDec(RoutedLen) < CDec(MinLen) Then
					cell.Item(row, 4) = RoutedLen
					cell.Item(row, 4).Font.Color = RGB(0, 0, 255)
					cell.Item(row, 5) = RoutedLen - MinLen
					cell.Item(row, 5).Font.Color = RGB(0, 0, 255)
				ElseIf CDec(RoutedLen) > CDec(MaxLen) Then
					cell.Item(row, 4).Font.Color = RGB(255, 0, 0)
					cell.Item(row, 4) = RoutedLen
					cell.Item(row, 5) = RoutedLen - MaxLen
					cell.Item(row, 5).Font.Color = RGB(255, 0, 0)
				Else
					cell.Item(row, 4) = RoutedLen
					cell.Item(row, 5) = "OK"
					cell.Item(row, 5).Font.Color = RGB(0, 255, 0)
				End If
				
				row = row + 1
			End If	
		End If
		
			Line Input #1,L1$
    Wend



	NetCount = NetCount + 1

	Next NextNet

Close #1
	On Error GoTo 0

	xl.Visible = True
	StatusBarText = ""

End Sub
